unit untMainClient;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WideStrings, DB, DBClient, SqlExpr, DSConnect, DbxDatasnap, Grids,
  DBGrids, StdCtrls, FMTBcd, DSHTTPLayer;

type
  TForm2 = class(TForm)
    SQLConnection1: TSQLConnection;
    ClientDataSet1: TClientDataSet;
    DSProviderConnection1: TDSProviderConnection;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    Edit1: TEdit;
    btnBuscar: TButton;
    Label1: TLabel;
    SqlServerMethod1: TSqlServerMethod;
    btnEchoString: TButton;
    edtString: TEdit;
    btnProxy: TButton;
    procedure btnBuscarClick(Sender: TObject);
    procedure btnEchoStringClick(Sender: TObject);
    procedure btnProxyClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses untClientProxy;

{$R *.dfm}

procedure TForm2.btnBuscarClick(Sender: TObject);
begin
  //Passa o valor do parmetro ao Client para que este seja repassado
  //para a aplicao servidora
  ClientDataSet1.Close;
  ClientDataSet1.Params[0].AsString:= Edit1.Text;
  ClientDataSet1.Open;
end;

procedure TForm2.btnEchoStringClick(Sender: TObject);
begin
  //Passa o parmetro para a funo mapeada pelo componente
  SqlServerMethod1.Params[0].AsString:= edtString.Text;

  //Executa o mtodo remoto do servidor
  SqlServerMethod1.ExecuteMethod;

  //Mostra mensage simples com o valor do retorno do mtodo
  ShowMessage(SqlServerMethod1.Params[1].AsString);
end;

procedure TForm2.btnProxyClick(Sender: TObject);
var
  ClientClass: TServerMethods1Client;
begin
  try
    //Cria uma instncia da classe proxy
    ClientClass:= TServerMethods1Client.Create(SQLConnection1.DBXConnection);

    //Faz a chamada ao mtodo remoto
    ShowMessage(ClientClass.EchoString(edtString.Text));
  finally
    //Libera a instncia da memria
    FreeAndNil(ClientClass);
  end;
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //Garante que a conexo seja fechada quando a aplicao for fechada
  SQLConnection1.Close;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
  //Garante que a conexo seja aberta ao iniciar a aplicao
  SQLConnection1.Open;
end;

end.
