unit uPrincipal;

interface

uses
  SysUtils, Classes, HTTPApp;

type
  TWebModule1 = class(TWebModule)
    procedure WebModule1waSessaoPHPAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  WebModule1: TWebModule1;

implementation

uses uPHPSessionFiles;

{$R *.dfm}

procedure TWebModule1.WebModule1waSessaoPHPAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  Sessao: TPHPSession;
  i: Integer;
begin
  //monta um texto introdutrio para a resposta
  Response.Content :=
    'O Webbroker processou a requisio e detectou os<br>' +
    ' seguintes valores armazenados em <b>' +
    Request.QueryFields.Values['savepath'] + '</b>,<br>' +
    ' na sesso de ID: <b>' + Request.QueryFields.Values['sessid'] +
    '</b>:<br><br>';

  //instancia o objeto que acessa a sesso do php,
  //passando o caminho de armazenamento e o ID da sesso
  Sessao := TPHPSession.Create(Request.QueryFields.Values['savepath'],
                               Request.QueryFields.Values['sessid']);
  try
    //percorre as variveis listando seus nomes e valores
    for i := 0 to Sessao.VarCount-1 do
      Response.Content := Response.Content +
        '<b>' + Sessao.GetVarName(i) + '</b> = ' + Sessao.GetValue(i) + '<br>';
  finally
    //libera o objeto da memria
    Sessao.Free;
  end;
end;

end.
